class QuantizableResNet(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv1 : __torch__.torch.nn.intrinsic.quantized.modules.conv_relu.ConvReLU2d
  bn1 : __torch__.torch.nn.modules.linear.Identity
  relu : __torch__.torch.nn.modules.linear.___torch_mangle_0.Identity
  maxpool : __torch__.torch.nn.modules.pooling.MaxPool2d
  layer1 : __torch__.torch.nn.modules.container.Sequential
  layer2 : __torch__.torch.nn.modules.container.___torch_mangle_33.Sequential
  layer3 : __torch__.torch.nn.modules.container.___torch_mangle_53.Sequential
  layer4 : __torch__.torch.nn.modules.container.___torch_mangle_73.Sequential
  avgpool : __torch__.torch.nn.modules.pooling.AdaptiveAvgPool2d
  fc : __torch__.torch.nn.quantized.modules.linear.Linear
  quant : __torch__.torch.nn.quantized.modules.Quantize
  dequant : __torch__.torch.nn.quantized.modules.DeQuantize
  def forward(self: __torch__.torchvision.models.quantization.resnet.QuantizableResNet,
    x: Tensor) -> Tensor:
    dequant = self.dequant
    fc = self.fc
    avgpool = self.avgpool
    layer4 = self.layer4
    layer3 = self.layer3
    layer2 = self.layer2
    layer1 = self.layer1
    maxpool = self.maxpool
    relu = self.relu
    bn1 = self.bn1
    conv1 = self.conv1
    quant = self.quant
    _0 = (conv1).forward((quant).forward(x, ), )
    _1 = (bn1).forward()
    _2 = (relu).forward()
    _3 = (layer1).forward((maxpool).forward(_0, ), )
    _4 = (layer3).forward((layer2).forward(_3, ), )
    _5 = (avgpool).forward((layer4).forward(_4, ), )
    x0 = torch.flatten(_5, 1)
    _6 = (dequant).forward((fc).forward(x0, ), )
    return _6
class QuantizableBasicBlock(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv1 : __torch__.torch.nn.intrinsic.quantized.modules.conv_relu.___torch_mangle_1.ConvReLU2d
  bn1 : __torch__.torch.nn.modules.linear.___torch_mangle_2.Identity
  relu : __torch__.torch.nn.modules.linear.___torch_mangle_3.Identity
  conv2 : __torch__.torch.nn.quantized.modules.conv.Conv2d
  bn2 : __torch__.torch.nn.modules.linear.___torch_mangle_4.Identity
  add_relu : __torch__.torch.nn.quantized.modules.functional_modules.QFunctional
  def forward(self: __torch__.torchvision.models.quantization.resnet.QuantizableBasicBlock,
    argument_1: Tensor) -> Tensor:
    add_relu = self.add_relu
    activation_post_process = add_relu.activation_post_process
    bn2 = self.bn2
    conv2 = self.conv2
    relu = self.relu
    bn1 = self.bn1
    conv1 = self.conv1
    _7 = (conv1).forward(argument_1, )
    _8 = (bn1).forward()
    _9 = (relu).forward()
    _10 = (conv2).forward(_7, )
    _11 = (bn2).forward()
    input = ops.quantized.add_relu(_10, argument_1, 0.034476079046726227, 0)
    _12 = (activation_post_process).forward()
    return input
