class QuantizableBasicBlock(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv1 : __torch__.torch.nn.intrinsic.quantized.modules.conv_relu.___torch_mangle_14.ConvReLU2d
  bn1 : __torch__.torch.nn.modules.linear.___torch_mangle_15.Identity
  relu : __torch__.torch.nn.modules.linear.___torch_mangle_16.Identity
  conv2 : __torch__.torch.nn.quantized.modules.conv.___torch_mangle_17.Conv2d
  bn2 : __torch__.torch.nn.modules.linear.___torch_mangle_18.Identity
  downsample : __torch__.torch.nn.modules.container.___torch_mangle_21.Sequential
  add_relu : __torch__.torch.nn.quantized.modules.functional_modules.___torch_mangle_23.QFunctional
  def forward(self: __torch__.torchvision.models.quantization.resnet.___torch_mangle_24.QuantizableBasicBlock,
    argument_1: Tensor) -> Tensor:
    add_relu = self.add_relu
    activation_post_process = add_relu.activation_post_process
    downsample = self.downsample
    bn2 = self.bn2
    conv2 = self.conv2
    relu = self.relu
    bn1 = self.bn1
    conv1 = self.conv1
    _0 = (conv1).forward(argument_1, )
    _1 = (bn1).forward()
    _2 = (relu).forward()
    _3 = (conv2).forward(_0, )
    _4 = (bn2).forward()
    input = ops.quantized.add_relu(_3, (downsample).forward(argument_1, ), 0.025826521217823029, 0)
    _5 = (activation_post_process).forward()
    return input
